GNU bug report logs - #12723
24.2; Improvement: changing text rectangle kill/past and its integration with the kill-ring

Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.

Package: emacs; Severity: wishlist; Reported by: Jiehong Ma <ma.jiehong@HIDDEN>; dated Wed, 24 Oct 2012 18:09:02 UTC; Maintainer for emacs is bug-gnu-emacs@HIDDEN.

Message received at 12723 <at> debbugs.gnu.org:


Received: (at 12723) by debbugs.gnu.org; 26 Oct 2012 01:36:26 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 25 21:36:26 2012
Received: from localhost ([127.0.0.1]:33919 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TRYqY-0007eJ-4I
	for submit <at> debbugs.gnu.org; Thu, 25 Oct 2012 21:36:26 -0400
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:8390)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1TRYqW-0007eC-Lv
	for 12723 <at> debbugs.gnu.org; Thu, 25 Oct 2012 21:36:25 -0400
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: Av0EAG6Zu0/O+LFW/2dsb2JhbABEtBGBCIIVAQEEAVYjBQsLNAcLFBgNJIgcBboJkEQDozOBWIMF
X-IronPort-AV: E=Sophos;i="4.75,637,1330923600"; d="scan'208";a="202889410"
Received: from 206-248-177-86.dsl.teksavvy.com (HELO pastel.home)
	([206.248.177.86])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	25 Oct 2012 21:34:17 -0400
Received: by pastel.home (Postfix, from userid 20848)
	id EBA0759347; Thu, 25 Oct 2012 21:34:15 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#12723: 24.2;
	Improvement: changing text rectangle kill/past and its
	integration	with the kill-ring
Message-ID: <jwv7gqe10gf.fsf-monnier+emacs@HIDDEN>
References: <5088281E.1080208@HIDDEN>
	<jwvlievem97.fsf-monnier+emacs@HIDDEN> <83625zbljf.fsf@HIDDEN>
	<jwvzk3bwaza.fsf-monnier+emacs@HIDDEN> <83zk3b9pcj.fsf@HIDDEN>
	<jwvfw523fqw.fsf-monnier+emacs@HIDDEN> <83txtia3x8.fsf@HIDDEN>
	<jwvip9y8l29.fsf-monnier+emacs@HIDDEN> <83k3ue9w2w.fsf@HIDDEN>
Date: Thu, 25 Oct 2012 21:34:15 -0400
In-Reply-To: <83k3ue9w2w.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 25 Oct
	2012 21:43:19 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.2.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 12723
Cc: ma.jiehong@HIDDEN, 12723 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.8 (/)

> A method that changes depending on the scripts involved would be
> confusing, I think.

That's OK: people can turn it off to get back the previous behavior of
not highlighting the rectangle but just the region.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#12723; Package emacs. Full text available.

Message received at 12723 <at> debbugs.gnu.org:


Received: (at 12723) by debbugs.gnu.org; 25 Oct 2012 19:45:25 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 25 15:45:25 2012
Received: from localhost ([127.0.0.1]:33693 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TRTMq-0006R3-8y
	for submit <at> debbugs.gnu.org; Thu, 25 Oct 2012 15:45:24 -0400
Received: from mtaout23.012.net.il ([80.179.55.175]:52962)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <eliz@HIDDEN>) id 1TRTMo-0006Qu-0g
	for 12723 <at> debbugs.gnu.org; Thu, 25 Oct 2012 15:45:23 -0400
Received: from conversion-daemon.a-mtaout23.012.net.il by
	a-mtaout23.012.net.il (HyperSendmail v2007.08) id
	<0MCG00L00RU5IA00@HIDDEN> for
	12723 <at> debbugs.gnu.org; Thu, 25 Oct 2012 21:43:15 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout23.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0MCG00LOKS42IJ00@HIDDEN>;
	Thu, 25 Oct 2012 21:43:15 +0200 (IST)
Date: Thu, 25 Oct 2012 21:43:19 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#12723: 24.2;
	Improvement: changing text rectangle kill/past and its
	integration	with the kill-ring
In-reply-to: <jwvip9y8l29.fsf-monnier+emacs@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Stefan Monnier <monnier@HIDDEN>
Message-id: <83k3ue9w2w.fsf@HIDDEN>
References: <5088281E.1080208@HIDDEN>
	<jwvlievem97.fsf-monnier+emacs@HIDDEN> <83625zbljf.fsf@HIDDEN>
	<jwvzk3bwaza.fsf-monnier+emacs@HIDDEN> <83zk3b9pcj.fsf@HIDDEN>
	<jwvfw523fqw.fsf-monnier+emacs@HIDDEN> <83txtia3x8.fsf@HIDDEN>
	<jwvip9y8l29.fsf-monnier+emacs@HIDDEN>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview: > From: Stefan Monnier <monnier@HIDDEN> >
	Cc: ma.jiehong@HIDDEN, 
	12723 <at> debbugs.gnu.org > Date: Thu, 25 Oct 2012 14:33:31 -0400 > > > It's
	one thing to leave the rectangle to the user's imagination and > >
	mental models;
	it's quite another to actually show that to her. It's > > quite
	possible
	the users today don't even bother looking what's > > between the two
	corners of the region. With it highlighted,
	they > > don't have a chance. > > There
	are several easy ways out: > - Let the user turn off highlighting. > -
	Let
	the user not look at the highlighting. > - Don't highlight if the text
	contains
	a mix of L2R and R2L (or just > highlight it in a simpler way that only
	shows the position of the > mark). [...] 
	Content analysis details:   (1.5 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	-0.0 RCVD_IN_DNSWL_NONE RBL: Sender listed at http://www.dnswl.org/,
	no trust [80.179.55.175 listed in list.dnswl.org]
	0.7 SPF_SOFTFAIL SPF: sender does not match SPF record (softfail)
	0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
	[score: 0.5000]
X-Debbugs-Envelope-To: 12723
Cc: ma.jiehong@HIDDEN, 12723 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org", has
 identified this incoming email as possible spam.  The original message
 has been attached to this so you can view it (if it isn't spam) or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  > From: Stefan Monnier <monnier@HIDDEN> > Cc: ma.jiehong@HIDDEN,
    12723 <at> debbugs.gnu.org > Date: Thu, 25 Oct 2012 14:33:31 -0400 > > > It's
   one thing to leave the rectangle to the user's imagination and > > mental
   models; it's quite another to actually show that to her. It's > > quite possible
    the users today don't even bother looking what's > > between the two corners
    of the region. With it highlighted, they > > don't have a chance. > > There
    are several easy ways out: > - Let the user turn off highlighting. > - Let
    the user not look at the highlighting. > - Don't highlight if the text contains
    a mix of L2R and R2L (or just > highlight it in a simpler way that only shows
    the position of the > mark). [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at http://www.dnswl.org/, no
                             trust
                             [80.179.55.175 listed in list.dnswl.org]
  0.7 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
                             [score: 0.5000]

> From: Stefan Monnier <monnier@HIDDEN>
> Cc: ma.jiehong@HIDDEN, 12723 <at> debbugs.gnu.org
> Date: Thu, 25 Oct 2012 14:33:31 -0400
> 
> > It's one thing to leave the rectangle to the user's imagination and
> > mental models; it's quite another to actually show that to her.  It's
> > quite possible the users today don't even bother looking what's
> > between the two corners of the region.  With it highlighted, they
> > don't have a chance.
> 
> There are several easy ways out:
> - Let the user turn off highlighting.
> - Let the user not look at the highlighting.
> - Don't highlight if the text contains a mix of L2R and R2L (or just
>   highlight it in a simpler way that only shows the position of the
>   mark).

How about this additional alternative: overlay the marked rectangle
with an overlay (pun intended) which has a 'display' property, a
string that's a copy of the marked text with a newline appended to
each (partial) line?  This display string will then look correctly
with or without bidirectional text, and it will also show the user how
the text will look if yanked into an empty buffer.  The only problem
is that sometimes some of the marked text will show to the left or
right of the overlay, but that's tolerable, I think, and we could make
the surrounding text pale so it's almost invisible.

> I think it should highlight the text actually selected, which doesn't
> give us much leeway.

The above suggestion fulfills that requirement.

> All I know is that the rectangle highlighting won't need complex
> bidi-aware code.  At most it will have to detect that there's bidi
> involved and fallback to another highlighting method.

A method that changes depending on the scripts involved would be
confusing, I think.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#12723; Package emacs. Full text available.

Message received at 12723 <at> debbugs.gnu.org:


Received: (at 12723) by debbugs.gnu.org; 25 Oct 2012 18:35:39 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 25 14:35:38 2012
Received: from localhost ([127.0.0.1]:33636 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TRSHK-0004pO-4O
	for submit <at> debbugs.gnu.org; Thu, 25 Oct 2012 14:35:38 -0400
Received: from chene.dit.umontreal.ca ([132.204.246.20]:47595)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1TRSHI-0004pH-RC
	for 12723 <at> debbugs.gnu.org; Thu, 25 Oct 2012 14:35:37 -0400
Received: from faina.iro.umontreal.ca (lechon.iro.umontreal.ca
	[132.204.27.242])
	by chene.dit.umontreal.ca (8.14.1/8.14.1) with ESMTP id q9PIXVhB015372; 
	Thu, 25 Oct 2012 14:33:31 -0400
Received: by faina.iro.umontreal.ca (Postfix, from userid 20848)
	id 4A055B4278; Thu, 25 Oct 2012 14:33:31 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#12723: 24.2;
	Improvement: changing text rectangle kill/past and its
	integration	with the kill-ring
Message-ID: <jwvip9y8l29.fsf-monnier+emacs@HIDDEN>
References: <5088281E.1080208@HIDDEN>
	<jwvlievem97.fsf-monnier+emacs@HIDDEN> <83625zbljf.fsf@HIDDEN>
	<jwvzk3bwaza.fsf-monnier+emacs@HIDDEN> <83zk3b9pcj.fsf@HIDDEN>
	<jwvfw523fqw.fsf-monnier+emacs@HIDDEN> <83txtia3x8.fsf@HIDDEN>
Date: Thu, 25 Oct 2012 14:33:31 -0400
In-Reply-To: <83txtia3x8.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 25 Oct
	2012 18:53:55 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.2 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-NAI-Spam-Flag: NO
X-NAI-Spam-Threshold: 5
X-NAI-Spam-Score: 0
X-NAI-Spam-Rules: 1 Rules triggered
	RV4382=0
X-NAI-Spam-Version: 2.2.0.9309 : core <4382> : streams <845340> : uri <1252295>
X-Spam-Score: -1.6 (-)
X-Debbugs-Envelope-To: 12723
Cc: ma.jiehong@HIDDEN, 12723 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -1.6 (-)

> It's one thing to leave the rectangle to the user's imagination and
> mental models; it's quite another to actually show that to her.  It's
> quite possible the users today don't even bother looking what's
> between the two corners of the region.  With it highlighted, they
> don't have a chance.

There are several easy ways out:
- Let the user turn off highlighting.
- Let the user not look at the highlighting.
- Don't highlight if the text contains a mix of L2R and R2L (or just
  highlight it in a simpler way that only shows the position of the
  mark).

>> Really, this issue is a complete non-issue
> I obviously disagree.

Then, let's just say that it's a bridge I'm not willing to cross before
we actually get there.

>> we're talking about reflecting on screen what is about to happen, so
>> any problem "on screen" (i.e. in the highlighting) is really due to
>> what's actually going to happen, not to
> It's not carved in stone that a rectangular region must be highlighted
> in the same way as the "normal" region.

I think it should highlight the text actually selected, which doesn't
give us much leeway.

> We could come up with something different, that doesn't suffer from
> the directionality issues, for example.

Fine by me.  All I know is that the rectangle highlighting won't need
complex bidi-aware code.  At most it will have to detect that there's
bidi involved and fallback to another highlighting method.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#12723; Package emacs. Full text available.

Message received at 12723 <at> debbugs.gnu.org:


Received: (at 12723) by debbugs.gnu.org; 25 Oct 2012 16:56:02 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 25 12:56:02 2012
Received: from localhost ([127.0.0.1]:33501 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TRQiw-0001gZ-1v
	for submit <at> debbugs.gnu.org; Thu, 25 Oct 2012 12:56:02 -0400
Received: from mtaout22.012.net.il ([80.179.55.172]:65195)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <eliz@HIDDEN>) id 1TRQit-0001g8-3a
	for 12723 <at> debbugs.gnu.org; Thu, 25 Oct 2012 12:56:00 -0400
Received: from conversion-daemon.a-mtaout22.012.net.il by
	a-mtaout22.012.net.il (HyperSendmail v2007.08) id
	<0MCG00K00JHQHC00@HIDDEN> for
	12723 <at> debbugs.gnu.org; Thu, 25 Oct 2012 18:53:51 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout22.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0MCG00KPOK9QIG30@HIDDEN>;
	Thu, 25 Oct 2012 18:53:51 +0200 (IST)
Date: Thu, 25 Oct 2012 18:53:55 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#12723: 24.2;
	Improvement: changing text rectangle kill/past and its
	integration	with the kill-ring
In-reply-to: <jwvfw523fqw.fsf-monnier+emacs@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Stefan Monnier <monnier@HIDDEN>
Message-id: <83txtia3x8.fsf@HIDDEN>
References: <5088281E.1080208@HIDDEN>
	<jwvlievem97.fsf-monnier+emacs@HIDDEN> <83625zbljf.fsf@HIDDEN>
	<jwvzk3bwaza.fsf-monnier+emacs@HIDDEN> <83zk3b9pcj.fsf@HIDDEN>
	<jwvfw523fqw.fsf-monnier+emacs@HIDDEN>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview: > From: Stefan Monnier <monnier@HIDDEN> >
	Cc: ma.jiehong@HIDDEN, 
	12723 <at> debbugs.gnu.org > Date: Thu, 25 Oct 2012 08:28:17 -0400 > > >> the
	highlighting would do the same since the highlighting is there > >> to
	make
	visible what the rectangle operations would/will do. > > IMHO,
	this doesn't
	make sense. The result will be complete confusion > > of the user wrt
	what
	parts of text are being selected. You should try > > that if you don't
	believe me. > > I'm sure it can be confusing. Yet,
	it reflects "which part of the > text is selected",
	just as much as the current region highlighting > does, 
	with the same amount of confusion [...] 
	Content analysis details:   (1.5 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	-0.0 RCVD_IN_DNSWL_NONE RBL: Sender listed at http://www.dnswl.org/,
	no trust [80.179.55.172 listed in list.dnswl.org]
	0.7 SPF_SOFTFAIL SPF: sender does not match SPF record (softfail)
	0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
	[score: 0.5000]
X-Debbugs-Envelope-To: 12723
Cc: ma.jiehong@HIDDEN, 12723 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org", has
 identified this incoming email as possible spam.  The original message
 has been attached to this so you can view it (if it isn't spam) or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  > From: Stefan Monnier <monnier@HIDDEN> > Cc: ma.jiehong@HIDDEN,
    12723 <at> debbugs.gnu.org > Date: Thu, 25 Oct 2012 08:28:17 -0400 > > >> the
   highlighting would do the same since the highlighting is there > >> to make
    visible what the rectangle operations would/will do. > > IMHO, this doesn't
    make sense. The result will be complete confusion > > of the user wrt what
    parts of text are being selected. You should try > > that if you don't believe
    me. > > I'm sure it can be confusing. Yet, it reflects "which part of the
    > text is selected", just as much as the current region highlighting > does,
    with the same amount of confusion [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at http://www.dnswl.org/, no
                             trust
                             [80.179.55.172 listed in list.dnswl.org]
  0.7 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
                             [score: 0.5000]

> From: Stefan Monnier <monnier@HIDDEN>
> Cc: ma.jiehong@HIDDEN,  12723 <at> debbugs.gnu.org
> Date: Thu, 25 Oct 2012 08:28:17 -0400
> 
> >> the highlighting would do the same since the highlighting is there
> >> to make visible what the rectangle operations would/will do.
> > IMHO, this doesn't make sense.  The result will be complete confusion
> > of the user wrt what parts of text are being selected.  You should try
> > that if you don't believe me.
> 
> I'm sure it can be confusing.  Yet, it reflects "which part of the
> text is selected", just as much as the current region highlighting
> does, with the same amount of confusion

The current region is one-dimensional, so the problem there is
smaller, and users of bidirectional scripts are already familiar with
it, because other applications behave in the same way.

> (except that we'd have several such regions, and an expectation that
> the combination should look rectangular).

Exactly.  Note that, depending on the characters present in each line,
there could be up to 3 distinct marked/unmarked portions inside the
rectangle on every line that has some part of it belonging to the
rectangle.

> I'm really not worried, tho: in those cases where it's really confusing,
> people probably don't use rectangle operations anyway (after all, if the
> highlighting is confusing yet reflects what's going to happen, it must
> be pretty difficult for the user to figure out in her head (i.e. without
> the highlighting help) what's going to happen).

It's one thing to leave the rectangle to the user's imagination and
mental models; it's quite another to actually show that to her.  It's
quite possible the users today don't even bother looking what's
between the two corners of the region.  With it highlighted, they
don't have a chance.

> Really, this issue is a complete non-issue

I obviously disagree.

> we're talking about reflecting on screen what is about to happen, so
> any problem "on screen" (i.e. in the highlighting) is really due to
> what's actually going to happen, not to

It's not carved in stone that a rectangular region must be highlighted
in the same way as the "normal" region.  We could come up with
something different, that doesn't suffer from the directionality
issues, for example.

> As soon as you write the code to "fix" kill-rectangle, I'm pretty
> sure updating the highlighting correspondingly will be easy.

Not sure who is "you" and what "fix" you have in mind.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#12723; Package emacs. Full text available.

Message received at 12723 <at> debbugs.gnu.org:


Received: (at 12723) by debbugs.gnu.org; 25 Oct 2012 12:30:28 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Thu Oct 25 08:30:28 2012
Received: from localhost ([127.0.0.1]:60821 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TRMZw-0002vp-GH
	for submit <at> debbugs.gnu.org; Thu, 25 Oct 2012 08:30:28 -0400
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:44764)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1TRMZv-0002ve-3G
	for 12723 <at> debbugs.gnu.org; Thu, 25 Oct 2012 08:30:27 -0400
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: Av0EAG6Zu0/O+LFW/2dsb2JhbABEtBGBCIIVAQEEAVYjBQsLNAcLFBgNJIgcBboJkEQDozOBWIMF
X-IronPort-AV: E=Sophos;i="4.75,637,1330923600"; d="scan'208";a="202808670"
Received: from 206-248-177-86.dsl.teksavvy.com (HELO pastel.home)
	([206.248.177.86])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	25 Oct 2012 08:28:17 -0400
Received: by pastel.home (Postfix, from userid 20848)
	id 6D704593D3; Thu, 25 Oct 2012 08:28:17 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#12723: 24.2;
	Improvement: changing text rectangle kill/past and its
	integration	with the kill-ring
Message-ID: <jwvfw523fqw.fsf-monnier+emacs@HIDDEN>
References: <5088281E.1080208@HIDDEN>
	<jwvlievem97.fsf-monnier+emacs@HIDDEN> <83625zbljf.fsf@HIDDEN>
	<jwvzk3bwaza.fsf-monnier+emacs@HIDDEN> <83zk3b9pcj.fsf@HIDDEN>
Date: Thu, 25 Oct 2012 08:28:17 -0400
In-Reply-To: <83zk3b9pcj.fsf@HIDDEN> (Eli Zaretskii's message of "Thu, 25 Oct
	2012 05:56:28 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.2.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 12723
Cc: ma.jiehong@HIDDEN, 12723 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.8 (/)

>> the highlighting would do the same since the highlighting is there
>> to make visible what the rectangle operations would/will do.
> IMHO, this doesn't make sense.  The result will be complete confusion
> of the user wrt what parts of text are being selected.  You should try
> that if you don't believe me.

I'm sure it can be confusing.  Yet, it reflects "which part of the text
is selected", just as much as the current region highlighting does, with
the same amount of confusion (except that we'd have several such
regions, and an expectation that the combination should look rectangular).

I'm really not worried, tho: in those cases where it's really confusing,
people probably don't use rectangle operations anyway (after all, if the
highlighting is confusing yet reflects what's going to happen, it must
be pretty difficult for the user to figure out in her head (i.e. without
the highlighting help) what's going to happen).

> So we have visual-line-mode on by default, but rectangle regions will
> disregard that completely and treat continued lines as one line?  Why
> does this make sense?

Don't know.  But that's what we have now and have had for eons.  Really,
this issue is a complete non-issue: we're talking about reflecting on
screen what is about to happen, so any problem "on screen" (i.e. in the
highlighting) is really due to what's actually going to happen, not to
the highlighting per se.  As soon as you write the code to "fix"
kill-rectangle, I'm pretty sure updating the highlighting
correspondingly will be easy.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#12723; Package emacs. Full text available.

Message received at 12723 <at> debbugs.gnu.org:


Received: (at 12723) by debbugs.gnu.org; 25 Oct 2012 03:58:36 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 24 23:58:36 2012
Received: from localhost ([127.0.0.1]:60373 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TREaa-00049F-4u
	for submit <at> debbugs.gnu.org; Wed, 24 Oct 2012 23:58:36 -0400
Received: from mtaout20.012.net.il ([80.179.55.166]:65089)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <eliz@HIDDEN>) id 1TREaX-000491-Sq
	for 12723 <at> debbugs.gnu.org; Wed, 24 Oct 2012 23:58:35 -0400
Received: from conversion-daemon.a-mtaout20.012.net.il by
	a-mtaout20.012.net.il (HyperSendmail v2007.08) id
	<0MCF00A00K241F00@HIDDEN> for
	12723 <at> debbugs.gnu.org; Thu, 25 Oct 2012 05:56:25 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout20.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0MCF009Y0KA1TQ60@HIDDEN>;
	Thu, 25 Oct 2012 05:56:25 +0200 (IST)
Date: Thu, 25 Oct 2012 05:56:28 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#12723: 24.2;
	Improvement: changing text rectangle kill/past and its
	integration	with the kill-ring
In-reply-to: <jwvzk3bwaza.fsf-monnier+emacs@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Stefan Monnier <monnier@HIDDEN>
Message-id: <83zk3b9pcj.fsf@HIDDEN>
References: <5088281E.1080208@HIDDEN>
	<jwvlievem97.fsf-monnier+emacs@HIDDEN> <83625zbljf.fsf@HIDDEN>
	<jwvzk3bwaza.fsf-monnier+emacs@HIDDEN>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview: > From: Stefan Monnier <monnier@HIDDEN> >
	Cc: ma.jiehong@HIDDEN, 12723 <at> debbugs.gnu.org > Date: Wed,
	24 Oct 2012 22:22:20 -0400 > > > How would
	such a rectangular highlighting behave when some of the text > > in the
	region
	is R2L and some L2R? Will it select text in visual > > order or in
	logical
	(buffer) order? > > The rectangle operations do not currently pay
	attention to this (they > work on logical order) [...] 
	Content analysis details:   (1.5 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	-0.0 RCVD_IN_DNSWL_NONE RBL: Sender listed at http://www.dnswl.org/,
	no trust [80.179.55.166 listed in list.dnswl.org]
	0.7 SPF_SOFTFAIL SPF: sender does not match SPF record (softfail)
	0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
	[score: 0.5000]
X-Debbugs-Envelope-To: 12723
Cc: ma.jiehong@HIDDEN, 12723 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org", has
 identified this incoming email as possible spam.  The original message
 has been attached to this so you can view it (if it isn't spam) or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  > From: Stefan Monnier <monnier@HIDDEN> > Cc: ma.jiehong@HIDDEN,
    12723 <at> debbugs.gnu.org > Date: Wed, 24 Oct 2012 22:22:20 -0400 > > > How would
    such a rectangular highlighting behave when some of the text > > in the region
    is R2L and some L2R? Will it select text in visual > > order or in logical
    (buffer) order? > > The rectangle operations do not currently pay attention
    to this (they > work on logical order) [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at http://www.dnswl.org/, no
                             trust
                             [80.179.55.166 listed in list.dnswl.org]
  0.7 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
                             [score: 0.5000]

> From: Stefan Monnier <monnier@HIDDEN>
> Cc: ma.jiehong@HIDDEN,  12723 <at> debbugs.gnu.org
> Date: Wed, 24 Oct 2012 22:22:20 -0400
> 
> > How would such a rectangular highlighting behave when some of the text
> > in the region is R2L and some L2R?  Will it select text in visual
> > order or in logical (buffer) order?
> 
> The rectangle operations do not currently pay attention to this (they
> work on logical order)

That goes without saying.  I was asking how this will be reflected on
the screen.

> the highlighting would do the same since the highlighting is there
> to make visible what the rectangle operations would/will do.

IMHO, this doesn't make sense.  The result will be complete confusion
of the user wrt what parts of text are being selected.  You should try
that if you don't believe me.

> Similarly, variable-width fonts and stuff would not require more work in
> the highlighting than in kill-rectangle.
> I'm not saying they're not relevant, but as long as kill-rectangle
> doesn't take them into account, the highlighting shouldn't either.

So we have visual-line-mode on by default, but rectangle regions will
disregard that completely and treat continued lines as one line?  Why
does this make sense?




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#12723; Package emacs. Full text available.

Message received at 12723 <at> debbugs.gnu.org:


Received: (at 12723) by debbugs.gnu.org; 25 Oct 2012 02:24:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 24 22:24:31 2012
Received: from localhost ([127.0.0.1]:60266 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TRD7X-0001zw-2X
	for submit <at> debbugs.gnu.org; Wed, 24 Oct 2012 22:24:31 -0400
Received: from ironport2-out.teksavvy.com ([206.248.154.182]:29617)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1TRD7U-0001zj-NX
	for 12723 <at> debbugs.gnu.org; Wed, 24 Oct 2012 22:24:29 -0400
X-IronPort-Anti-Spam-Filtered: true
X-IronPort-Anti-Spam-Result: Av0EAG6Zu0/O+LFW/2dsb2JhbABEtBGBCIIVAQEEAVYcBwULCy0HBwsUGA0kiBwFugmNGoMqA6MzgViDBQ
X-IronPort-AV: E=Sophos;i="4.75,637,1330923600"; d="scan'208";a="202672770"
Received: from 206-248-177-86.dsl.teksavvy.com (HELO fmsmemgm.homelinux.net)
	([206.248.177.86])
	by ironport2-out.teksavvy.com with ESMTP/TLS/ADH-AES256-SHA;
	24 Oct 2012 22:22:21 -0400
Received: by fmsmemgm.homelinux.net (Postfix, from userid 20848)
	id DA510AE4BB; Wed, 24 Oct 2012 22:22:20 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#12723: 24.2;
	Improvement: changing text rectangle kill/past and its
	integration	with the kill-ring
Message-ID: <jwvzk3bwaza.fsf-monnier+emacs@HIDDEN>
References: <5088281E.1080208@HIDDEN>
	<jwvlievem97.fsf-monnier+emacs@HIDDEN> <83625zbljf.fsf@HIDDEN>
Date: Wed, 24 Oct 2012 22:22:20 -0400
In-Reply-To: <83625zbljf.fsf@HIDDEN> (Eli Zaretskii's message of "Wed, 24 Oct
	2012 23:35:48 +0200")
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.2.50 (gnu/linux)
MIME-Version: 1.0
Content-Type: text/plain
X-Spam-Score: 0.8 (/)
X-Debbugs-Envelope-To: 12723
Cc: ma.jiehong@HIDDEN, 12723 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 0.8 (/)

> How would such a rectangular highlighting behave when some of the text
> in the region is R2L and some L2R?  Will it select text in visual
> order or in logical (buffer) order?

The rectangle operations do not currently pay attention to this (they
work on logical order) and the highlighting would do the same since the
highlighting is there to make visible what the rectangle operations
would/will do.

> Anyway, doing this kind of stuff in Lisp is not trivial even if we
> disregard the bidirectional text issue, because variable-size fonts,
> double-width characters, composed characters, display strings, and
> other display atrocities complicate the 1:1 relation between buffer
> text and what's on the glass.

Similarly, variable-width fonts and stuff would not require more work in
the highlighting than in kill-rectangle.
I'm not saying they're not relevant, but as long as kill-rectangle
doesn't take them into account, the highlighting shouldn't either.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#12723; Package emacs. Full text available.

Message received at 12723 <at> debbugs.gnu.org:


Received: (at 12723) by debbugs.gnu.org; 24 Oct 2012 21:38:01 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 24 17:38:01 2012
Received: from localhost ([127.0.0.1]:60111 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TR8eH-0003tv-1I
	for submit <at> debbugs.gnu.org; Wed, 24 Oct 2012 17:38:01 -0400
Received: from mtaout20.012.net.il ([80.179.55.166]:59017)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <eliz@HIDDEN>) id 1TR8eE-0003ta-19
	for 12723 <at> debbugs.gnu.org; Wed, 24 Oct 2012 17:37:59 -0400
Received: from conversion-daemon.a-mtaout20.012.net.il by
	a-mtaout20.012.net.il (HyperSendmail v2007.08) id
	<0MCF006002NBSX00@HIDDEN> for
	12723 <at> debbugs.gnu.org; Wed, 24 Oct 2012 23:35:46 +0200 (IST)
Received: from HOME-C4E4A596F7 ([87.69.4.28]) by a-mtaout20.012.net.il
	(HyperSendmail v2007.08) with ESMTPA id
	<0MCF006VS2NMAHB0@HIDDEN>;
	Wed, 24 Oct 2012 23:35:46 +0200 (IST)
Date: Wed, 24 Oct 2012 23:35:48 +0200
From: Eli Zaretskii <eliz@HIDDEN>
Subject: Re: bug#12723: 24.2;
	Improvement: changing text rectangle kill/past and its
	integration	with the kill-ring
In-reply-to: <jwvlievem97.fsf-monnier+emacs@HIDDEN>
X-012-Sender: halo1@HIDDEN
To: Stefan Monnier <monnier@HIDDEN>
Message-id: <83625zbljf.fsf@HIDDEN>
References: <5088281E.1080208@HIDDEN>
	<jwvlievem97.fsf-monnier+emacs@HIDDEN>
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview: > From: Stefan Monnier <monnier@HIDDEN> >
	Date:
	Wed, 24 Oct 2012 14:59:22 -0400 > Cc: 12723 <at> debbugs.gnu.org > > Also,
	I'd
	expect the rectangular highlighting to be done by moving the >
	region-highlighting
	code to Elisp (using the previously-mentioned > but vaporware
	before-redisplay-hook). [...] 
	Content analysis details:   (1.5 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	-0.0 RCVD_IN_DNSWL_NONE RBL: Sender listed at http://www.dnswl.org/,
	no trust [80.179.55.166 listed in list.dnswl.org]
	0.7 SPF_SOFTFAIL SPF: sender does not match SPF record (softfail)
	0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
	[score: 0.5000]
X-Debbugs-Envelope-To: 12723
Cc: ma.jiehong@HIDDEN, 12723 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
Reply-To: Eli Zaretskii <eliz@HIDDEN>
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org", has
 identified this incoming email as possible spam.  The original message
 has been attached to this so you can view it (if it isn't spam) or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  > From: Stefan Monnier <monnier@HIDDEN> > Date:
   Wed, 24 Oct 2012 14:59:22 -0400 > Cc: 12723 <at> debbugs.gnu.org > > Also, I'd
   expect the rectangular highlighting to be done by moving the > region-highlighting
    code to Elisp (using the previously-mentioned > but vaporware before-redisplay-hook).
    [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at http://www.dnswl.org/, no
                             trust
                             [80.179.55.166 listed in list.dnswl.org]
  0.7 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
                             [score: 0.5000]

> From: Stefan Monnier <monnier@HIDDEN>
> Date: Wed, 24 Oct 2012 14:59:22 -0400
> Cc: 12723 <at> debbugs.gnu.org
> 
> Also, I'd expect the rectangular highlighting to be done by moving the
> region-highlighting code to Elisp (using the previously-mentioned
> but vaporware before-redisplay-hook).

How would such a rectangular highlighting behave when some of the text
in the region is R2L and some L2R?  Will it select text in visual
order or in logical (buffer) order?

Anyway, doing this kind of stuff in Lisp is not trivial even if we
disregard the bidirectional text issue, because variable-size fonts,
double-width characters, composed characters, display strings, and
other display atrocities complicate the 1:1 relation between buffer
text and what's on the glass.  In fact, I had hard time doing that in
C with bidi-aware mouse highlight.  And AFAICT, we have no facilities
to access display-related structures from Lisp.

So I'd suggest that if someone wants to work on this, he or she
presents a detailed design first regarding the above complications.




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#12723; Package emacs. Full text available.

Message received at 12723 <at> debbugs.gnu.org:


Received: (at 12723) by debbugs.gnu.org; 24 Oct 2012 19:01:31 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 24 15:01:31 2012
Received: from localhost ([127.0.0.1]:60006 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TR6Co-0000Lb-Tz
	for submit <at> debbugs.gnu.org; Wed, 24 Oct 2012 15:01:31 -0400
Received: from relais.videotron.ca ([24.201.245.36]:34971)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <monnier@HIDDEN>) id 1TR6Cn-0000LU-8y
	for 12723 <at> debbugs.gnu.org; Wed, 24 Oct 2012 15:01:29 -0400
MIME-version: 1.0
Content-transfer-encoding: 7BIT
Content-type: text/plain; CHARSET=US-ASCII
Received: from ceviche.home ([96.21.127.30]) by VL-VM-MR004.ip.videotron.ca
	(Oracle Communications Messaging Exchange Server 7u4-22.01 64bit (built
	Apr 21
	2011)) with ESMTP id <0MCE005RUVEY2Q40@HIDDEN> for
	12723 <at> debbugs.gnu.org; Wed, 24 Oct 2012 14:59:22 -0400 (EDT)
Received: by ceviche.home (Postfix, from userid 20848)	id 2554A661F0; Wed,
	24 Oct 2012 14:59:22 -0400 (EDT)
From: Stefan Monnier <monnier@HIDDEN>
To: Jiehong Ma <ma.jiehong@HIDDEN>
Subject: Re: bug#12723: 24.2; Improvement: changing text rectangle kill/past
	and its integration with the kill-ring
Message-id: <jwvlievem97.fsf-monnier+emacs@HIDDEN>
References: <5088281E.1080208@HIDDEN>
Date: Wed, 24 Oct 2012 14:59:22 -0400
In-reply-to: <5088281E.1080208@HIDDEN>
User-Agent: Gnus/5.13 (Gnus v5.13) Emacs/24.2.50 (gnu/linux)
X-Spam-Score: 1.6 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org",
	has
	identified this incoming email as possible spam. The original message
	has been attached to this so you can view it (if it isn't spam) or
	label similar future email.  If you have any questions, see
	the administrator of that system for details.
	Content preview:  > In the following,
	I would like to present how I think it would be > nicer,
	and also more accessible to users. 100% agreement. That's
	exactly how I want it to work, as well. More specifically,
	I'd expect `mark-active'
	to take a special `rectangle' value to mean that the current selection
	is a rectangular region. [...] 
	Content analysis details:   (1.6 points, 10.0 required)
	pts rule name              description
	---- ----------------------
	--------------------------------------------------
	-0.0 RCVD_IN_DNSWL_NONE RBL: Sender listed at http://www.dnswl.org/,
	no trust [24.201.245.36 listed in list.dnswl.org]
	0.7 SPF_SOFTFAIL SPF: sender does not match SPF record (softfail)
	0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
	[score: 0.5000]
	0.1 HDRS_LCASE             Odd capitalization of message header
	0.0 T_MANY_HDRS_LCASE Odd capitalization of multiple message headers
X-Debbugs-Envelope-To: 12723
Cc: 12723 <at> debbugs.gnu.org
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: 1.5 (+)
X-Spam-Report: Spam detection software, running on the system "debbugs.gnu.org", has
 identified this incoming email as possible spam.  The original message
 has been attached to this so you can view it (if it isn't spam) or label
 similar future email.  If you have any questions, see
 the administrator of that system for details.
 
 Content preview:  > In the following, I would like to present how I think it
    would be > nicer, and also more accessible to users. 100% agreement. That's
    exactly how I want it to work, as well. More specifically, I'd expect `mark-active'
    to take a special `rectangle' value to mean that the current selection is
    a rectangular region. [...] 
 
 Content analysis details:   (1.5 points, 10.0 required)
 
  pts rule name              description
 ---- ---------------------- --------------------------------------------------
 -0.0 RCVD_IN_DNSWL_NONE     RBL: Sender listed at http://www.dnswl.org/, no
                             trust
                             [24.201.245.36 listed in list.dnswl.org]
  0.7 SPF_SOFTFAIL           SPF: sender does not match SPF record (softfail)
  0.8 BAYES_50               BODY: Bayes spam probability is 40 to 60%
                             [score: 0.5000]

> In the following, I would like to present how I think it would be
> nicer, and also more accessible to users.

100% agreement.  That's exactly how I want it to work, as well.

More specifically, I'd expect `mark-active' to take a special
`rectangle' value to mean that the current selection is
a rectangular region.

Also, I'd expect the rectangular highlighting to be done by moving the
region-highlighting code to Elisp (using the previously-mentioned
but vaporware before-redisplay-hook).

As for how to store the rectangles on the kill-ring, I haven't really
thought about it yet.  We could maybe store them as strings with
a special text-property annotation, or as lists of strings, or as a cons
cell (rectange . STRING).  The first option is probably best
compatibility-wise, while the second would be a step in the direction of
supporting general non-contiguous regions.


        Stefan




Information forwarded to bug-gnu-emacs@HIDDEN:
bug#12723; Package emacs. Full text available.

Message received at submit <at> debbugs.gnu.org:


Received: (at submit) by debbugs.gnu.org; 24 Oct 2012 18:08:18 +0000
From debbugs-submit-bounces <at> debbugs.gnu.org Wed Oct 24 14:08:18 2012
Received: from localhost ([127.0.0.1]:59944 helo=debbugs.gnu.org)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <debbugs-submit-bounces <at> debbugs.gnu.org>)
	id 1TR5NJ-0006eO-QI
	for submit <at> debbugs.gnu.org; Wed, 24 Oct 2012 14:08:18 -0400
Received: from eggs.gnu.org ([208.118.235.92]:47261)
	by debbugs.gnu.org with esmtp (Exim 4.72)
	(envelope-from <ma.jiehong@HIDDEN>) id 1TR4z5-00062S-OG
	for submit <at> debbugs.gnu.org; Wed, 24 Oct 2012 13:43:16 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <ma.jiehong@HIDDEN>) id 1TR4x4-0000MD-RQ
	for submit <at> debbugs.gnu.org; Wed, 24 Oct 2012 13:41:11 -0400
X-Spam-Checker-Version: SpamAssassin 3.3.2 (2011-06-06) on eggs.gnu.org
X-Spam-Level: 
X-Spam-Status: No, score=-6.9 required=5.0 tests=BAYES_00,FREEMAIL_FROM,
	RCVD_IN_DNSWL_HI,T_DKIM_INVALID autolearn=unavailable version=3.3.2
Received: from lists.gnu.org ([208.118.235.17]:34429)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <ma.jiehong@HIDDEN>) id 1TR4x4-0000M2-Bw
	for submit <at> debbugs.gnu.org; Wed, 24 Oct 2012 13:41:10 -0400
Received: from eggs.gnu.org ([208.118.235.92]:35487)
	by lists.gnu.org with esmtp (Exim 4.71)
	(envelope-from <ma.jiehong@HIDDEN>) id 1TR4x3-0005Jg-0C
	for bug-gnu-emacs@HIDDEN; Wed, 24 Oct 2012 13:41:10 -0400
Received: from Debian-exim by eggs.gnu.org with spam-scanned (Exim 4.71)
	(envelope-from <ma.jiehong@HIDDEN>) id 1TR4ws-0000IF-3V
	for bug-gnu-emacs@HIDDEN; Wed, 24 Oct 2012 13:41:08 -0400
Received: from mail-bk0-f41.google.com ([209.85.214.41]:59550)
	by eggs.gnu.org with esmtp (Exim 4.71)
	(envelope-from <ma.jiehong@HIDDEN>) id 1TR4wr-0000G4-Sn
	for bug-gnu-emacs@HIDDEN; Wed, 24 Oct 2012 13:40:58 -0400
Received: by mail-bk0-f41.google.com with SMTP id jm1so388356bkc.0
	for <bug-gnu-emacs@HIDDEN>; Wed, 24 Oct 2012 10:40:49 -0700 (PDT)
DKIM-Signature: v=1; a=rsa-sha256; c=relaxed/relaxed; d=gmail.com; s=20120113;
	h=message-id:date:from:user-agent:mime-version:to:subject
	:content-type:content-transfer-encoding;
	bh=18cI0xbsTjPmy5jqXis52Iu/mrZOJuB3YlSMB+6pYys=;
	b=dNC4JVuqmyWjLOlmHokOnaKqSuMHWgvz/wYZvyRs/tjyLAtlF9N3i59hm/uJYt00LI
	RbIUyGGkaDDmYWaXdHWFVv5xTiysssWc4m5PCRTTyZjOjxz77gPYkoEFoPwZ8NDlbqPs
	MZ3EnjeznCUKBalPOAoi5ub16ljDKyuiaTzBstFoa4YLWkCYK+OMCR5P7BK42qvSGYqO
	rMxemVXUeGDhu1Gaz5hl7/g4Xxj8ePzPXo0TWIy1FBLHcUtxT1cnGjlTCqdIqlKXf0Bt
	pjVzr+Hpk8XPuGVL0tcRe5qL1dqEHGlXcNR62lgTsGpf19jLVJXWaJNlkogBMnk2foLF
	jq+Q==
Received: by 10.204.149.10 with SMTP id r10mr5020256bkv.61.1351100449792;
	Wed, 24 Oct 2012 10:40:49 -0700 (PDT)
Received: from [10.0.201.59] ([78.250.137.8])
	by mx.google.com with ESMTPS id 9sm8848318bkq.13.2012.10.24.10.40.47
	(version=SSLv3 cipher=OTHER); Wed, 24 Oct 2012 10:40:48 -0700 (PDT)
Message-ID: <5088281E.1080208@HIDDEN>
Date: Wed, 24 Oct 2012 19:40:46 +0200
From: Jiehong Ma <ma.jiehong@HIDDEN>
User-Agent: Mozilla/5.0 (X11; Linux x86_64;
	rv:16.0) Gecko/20121012 Thunderbird/16.0.1
MIME-Version: 1.0
To: bug-gnu-emacs@HIDDEN
Subject: 24.2;
	Improvement: changing text rectangle kill/past and its integration
	with the kill-ring
Content-Type: text/plain; charset=UTF-8; format=flowed
Content-Transfer-Encoding: 7bit
X-detected-operating-system: by eggs.gnu.org: Genre and OS details not
	recognized.
X-detected-operating-system: by eggs.gnu.org: GNU/Linux 2.6 (newer, 3)
X-Received-From: 208.118.235.17
X-Spam-Score: -3.4 (---)
X-Debbugs-Envelope-To: submit
X-Mailman-Approved-At: Wed, 24 Oct 2012 14:08:16 -0400
X-BeenThere: debbugs-submit <at> debbugs.gnu.org
X-Mailman-Version: 2.1.13
Precedence: list
List-Id: <debbugs-submit.debbugs.gnu.org>
List-Unsubscribe: <http://debbugs.gnu.org/cgi-bin/mailman/options/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=unsubscribe>
List-Archive: <http://debbugs.gnu.org/cgi-bin/mailman/private/debbugs-submit>
List-Post: <mailto:debbugs-submit <at> debbugs.gnu.org>
List-Help: <mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=help>
List-Subscribe: <http://debbugs.gnu.org/cgi-bin/mailman/listinfo/debbugs-submit>,
	<mailto:debbugs-submit-request <at> debbugs.gnu.org?subject=subscribe>
Sender: debbugs-submit-bounces <at> debbugs.gnu.org
Errors-To: debbugs-submit-bounces <at> debbugs.gnu.org
X-Spam-Score: -3.4 (---)

This is actually a kind of improvement I would like to submit here.

We all know how rectangle selections are working with registers. The idea
of having a rectangle selection is great, but the key-bindings to use
it is far from that adjective. In the following, I would like to
present how I think it would be nicer, and also more accessible to
users.

1. Every selection should start, and act the same way, i.e. by using C-SPC.

2. While the selection is active, switch into a rectangular-mode thanks
to a key-binding (I propose C-x r), and visually show it to the user.
(as does the rect-mark package for example).

3. When the rectangular selection is fully chosen by the user, use a
=E2=80=9Cnormal=E2=80=9D function to kill it: C-w, M-w.

4. Give access to this rectangle in the kill-ring directly (no need to
name a register).

5. When the user yank a normal piece of text, act as usual. However, if
the current entry in the buffer is a rectangle, yang it accordingly (
for both C-y, M-y)

Having such a work-flow would make the usage of text-rectangle selection
a piece of cake, since we would only need to remember 1 key-binding to
switch the selection into a rectangle-mode.

Registers could be bind to different key-bindings as well.

Technically, I do not really know how to do that. I thought that it may
be possible to actually keep a kind of pointer into the kill ring,
pointing to a register having a unique name. Maybe it could be simpler.
I can't tell, since my knowledge of elisp is limited.

Jiehong Ma

In GNU Emacs 24.2.1 (x86_64-unknown-linux-gnu, GTK+ Version 3.4.4)
  of 2012-08-28 on shaun
Windowing system distributor `The X.Org Foundation




Acknowledgement sent to Jiehong Ma <ma.jiehong@HIDDEN>:
New bug report received and forwarded. Copy sent to bug-gnu-emacs@HIDDEN. Full text available.
Report forwarded to bug-gnu-emacs@HIDDEN:
bug#12723; Package emacs. Full text available.
Please note: This is a static page, with minimal formatting, updated once a day.
Click here to see this page with the latest information and nicer formatting.
Last modified: Fri, 31 Oct 2014 17:00:04 UTC

GNU bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997 nCipher Corporation Ltd, 1994-97 Ian Jackson.